#include <stdio.h>
#include <ctype.h>
#include <unistd.h>
#include <signal.h>
#include <string.h>
#include <stdlib.h>
#include "ll.h"
#include "parse.h"
#include "test.h"
#include "regenerate.h"
#include "ploptim.h"

char *best, *new;
int lb, ln;
void output_best(int sigid);

int main(int argc, char *argv[])
{
  field **display;
  char c;
  int size = 0;
  property orig;
  unsigned int timer;

  timer = (argc > 1) ? strtol(argv[1], NULL, 10) : 6;

  alarm(timer - 6);

  signal(SIGALRM, output_best);

  best = NULL;
  new = NULL;

  lb = 0;
  while ((c = getchar()) != EOF)
    {  
      if (size < (++lb)) 
	{
	  size += 1000;
	  best = (char *)realloc((void *)best, sizeof(char) * size);
	}
      
      best[lb - 1] = c;
      best[lb] = '\0';
    }

  orig.pl = orig.b = orig.em = orig.i = orig.s = orig.tt = orig.u = 0;
  orig.color = 'a';
  orig.size = -1;

  //  fprintf(stderr, "%s\n\n", best);

  display = parse(best);
  //  show_display(display);
  pl_optimization(display);
  //  show_display(display);

  new = regenerate(bottom(display), top(display), orig, NULL, 0);
  //  show_display(display);

  output_best(0);

  //printf("%s", new);

  return 0;

}

void output_best(int sigid)
{
  if (new != NULL && (ln = strlen(new)) < lb)
    printf("%s", new);
  else
    printf("%s", best);

  exit(0);
  return;
}
