#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "parse.h"
#include "ll.h"
#include "test.h"

#ifndef NULL
#define NULL (void *)0
#endif

void init_stack(field ***stack)
{
  (* stack) = (field **)malloc(sizeof(field *));
  (*(* stack)) = NULL;
}

field **stack;

/*WARNING: Written while intoxicated*/
field **parse(char *input)
{
  field **display;

  short state = 0;
  property context,         //context based on the tags
    next_context,           //context after current tag is processed
    space_context,          //context for a space for current context
    last_context,           //context that is active with current field
    last_space_context;     //last space context
  char *text;
  int size = 1, c = -1;

  text = (char *)malloc(sizeof(char));
  text[0] = '\0';

  //set the original context
  context.pl = context.b = context.em = context.i = context.s = context.tt = context.u = 0;
  context.color = 'a';
  context.size = -1;

  last_space_context = last_context = context;

  init_stack(&stack);
  init_stack(&display);
  
  //actually go through and do the parsing
  while (input[++c] != '\0')
    {
      /*
      fprintf(stderr, "%3d %c, %d, <%s><%s><%s><%s>\n", c, input[c], state, 
	      show_context(context), show_context(last_context), 
	      show_context((spaceify(context))), show_context(last_space_context));
      */
      switch (state)
	{
	case 0:
	case 3:
	case 6:
	  if (input[c] == '<')
	    state++;
	  else if (isgraph(input[c]))   ///got a non-white space
	    {
	      //if our current section has either doesn't match, or
	      //it only has a space, but the space is incompatible
	      if ((!properties_equal(last_context, context) && state != 6) || 
		  (!properties_equal(last_space_context, spaceify(context)) &&  state == 6))
		{
		  if (text[0] != '\0') 
		    addfield(display, last_context, text);
		  last_context = context;
		  text[0] = '\0';
		}
	      else if (state == 6)
		last_context = context;
	      addchar(&text, &size, input[c]);
	      state = 0;
	    } 
	  else // shitty, we done got a space
	    {
	      space_context = spaceify(context);
	      //if we either only have a space that doesn't match, or
	      //we don't match 
	      if (!properties_equal((state == 6) ? last_space_context : spaceify(last_context), space_context))
		{
		  if (text[0] != '\0')
		    addfield(display, (state == 6) ? last_space_context : last_context, text);
		  text[0] = '\0';
		  state = 6;
		  addchar(&text, &size, ' ');		    
		  last_context = context;
		}
	      //if we have TT set and the spaces match, or we didn't just have a space and they match
	      else if (context.tt || (state != 3 && state != 6))
		{
		  addchar(&text, &size, ' ');
		  state = 3;
		}
	      last_space_context = space_context;
	    }
	  break;
	case 1:
	case 4:
	case 7:
	  switch (input[c])
	    {
	    case '/' :
	      state++;
	      break;
	    case 'B' :
	      next_context = context;
	      next_context.b = 1;
	      break;
	    case 'E' :
	      next_context = context;
	      next_context.em = (next_context.s) ? next_context.em : ((next_context.em + 1) % 2);
	      break;
	    case 'I' :
	      next_context = context;
	      next_context.i = 1;
	      break;
	    case 'P' :
	      next_context = context;
	      next_context.s = 0;
	      next_context.em = 0;
	      next_context.i = 0;
	      next_context.b = 0;
	      next_context.tt = 0;
	      next_context.u = 0;
	      break;
	    case 'S' :
	      next_context = context;
	      next_context.em = 0;
	      next_context.s = 1;
	      break;
	    case 'T' :
	      next_context = context;
	      next_context.tt = 1;
	      break;
	    case 'U' :
	      next_context = context;
	      next_context.u += (next_context.u < 3) ? 1 : 0;
	      break;
	    default :
	      if (isdigit(input[c]))
		{
		  next_context = context;
		  next_context.size = input[c] - '0';
		}
	      else if (iscolor(input[c]))
		{
		  next_context = context;
		  next_context.color = input[c];
		}
	      else
		  fprintf(stderr, "Got '%c' inside a tag\n", input[c]);
	    }
	  if (state != 2 && state != 5 && state != 8)
	    {
	      state--;
	      while (input[++c] != '>');
	      addfield(stack, context, "");
	      context = next_context;
	    }
	  break;
	case 2 :
	case 5 :
	case 8 :
	  while (input[++c] != '>');
	  context = poptop(stack)->prop;
	  state -= 2;
	  break;
	}
    }

  addfield(display, last_context, text);

  return display;
}

property spaceify(property prop)
{
  prop.s = prop.em = prop.i = prop.b = 0;
  prop.color = (prop.u == 0) ? 'w' : prop.color;

  return prop;
}


void addchar(char **text, int *size, char c)
{
  int l;

  l = strlen(* text);
     
  if ((* text) == NULL) 
    {
      (* size) = 100;
      (* text) = (char *)malloc(sizeof(char) * (* size));
      (* text)[0] = '\0';
    }
  else if ((* size) < (l + 2)) 
    {
      (* size) += 100;
      (* text) = realloc((* text), sizeof(char) * (* size));
    }

  (* text)[l + 1] = '\0';
  (* text)[l] = c;

  return;
}
 
int iscolor(char c)
{
  return (c == 'r' || c == 'g' || c == 'b' || c == 'c' || 
	  c == 'm' || c == 'y' || c == 'k' || c == 'w' );
}

//This means do they look the same... pl is ommitted on purpose
int properties_equal(property p1, property p2)
{
  int temp = (p1.b == p2.b && p1.em == p2.em && p1.i == p2.i && p1.size == p2.size && 
	      p1.u == p2.u && p1.tt == p2.tt && p1.s == p2.s && p1.color == p2.color );

  /*
  printf("%8s<%s><%s>\n", 
	 (temp) ? "equal:" : "unequal:", 
	 show_context(p1),
	 show_context(p2));
  */	 

  return temp;
}

