#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "ll.h"
#include "parse.h"
#include "regenerate.h"
#include "test.h"

char *regenerate(field *bottom, field *top, property context, char *colors, int sizes)
{
  char *pre, ot[5], ct[6], max_ot[5], max_ct[6], *temp, oldcolors[10], max_colors[10];
  int size = 1, length, count, max;
  property next_context, max_context;
  field *b;
  field *next_top;
  field *max_bottom;
  int oldsizes, max_sizes;

  if (colors == NULL)
    {
      colors = (char *)malloc(10 * sizeof(char));
      strcpy(colors, "a");
    }

  if (sizes == 0)
    sizes = 1;

  strcpy(oldcolors, colors);
  oldsizes = sizes;

  /*
  fprintf(stderr, "context:<%s>\n", 
	  show_context(context));
  fprintf(stderr, "bottom: ");
  show_field(bottom);
  fprintf(stderr, "top:    ");
  show_field(top);
  */

  pre = (char *)malloc(sizeof(char));
  pre[0] = '\0';
  
  if (bottom == NULL)
    return pre;

  //this should add it on even if it has a pl tag set incorrectly
  if (properties_equal(bottom->prop, context))
    {
      addstring(&pre, &size, bottom->text);
      bottom = bottom->next;
    }

  //if we just got rid of the last thing 
  if (bottom == NULL || bottom == top->next)
    return pre;

  b = bottom;
  
  count = 1;
  while(b != top)
    {
      b = b->next;
      count++;
    }

  b = bottom;
  max = -1;
  
  while (max < count-- && b != NULL && b != top->next)
    {
      strcpy(colors, oldcolors);
      sizes = oldsizes;
      length = property_length(b, top, difference(context, b->prop), context, &next_context, ot, ct, colors, &sizes);
      if (length > max)
	{
	  strcpy(max_colors, colors);
	  max_sizes = sizes;
	  strcpy(max_ot, ot);
	  strcpy(max_ct, ct);
	  max_bottom = b;
	  max_context = next_context;
	  max = length;
	}
      b = b->next;
    }

  //  fprintf(stderr, "max count is %2d\n", max);

  count = 1;

  next_top = max_bottom;
  while (count++ < max)
    next_top = next_top->next;
 
  if (bottom != max_bottom && max_bottom->prev != NULL)
    {
      strcpy(colors, oldcolors);
      //fprintf(stderr, "inner:\n");
      //fprintf(stderr, "%p:%p:%p\n", bottom, max_bottom->prev, max_bottom);
      temp = regenerate(bottom, max_bottom->prev, context, colors, oldsizes);
      addstring(&pre, &size, temp);
      free(temp);
    }

  //fprintf(stderr, "middl:\n");
  //fprintf(stderr, "%p:%p:%p\n", max_bottom, next_top, next_top->next);
  addstring(&pre, &size, max_ot);
  strcpy(colors, max_colors);
  temp = regenerate(max_bottom, next_top, max_context, colors, sizes);
  addstring(&pre, &size, temp);
  free(temp);
  addstring(&pre, &size, max_ct);
  if (next_top == top)
    return pre;

  //fprintf(stderr, "outer:\n");
  //fprintf(stderr, "%p:%p:\n", next_top->next, top);
  strcpy(colors, oldcolors);
  temp = regenerate(next_top->next, top, context, colors, oldsizes);
  addstring(&pre, &size, temp);
  free(temp);
  
  return pre;
}

property difference(property p1, property p2)
{
  property diff;

  diff.pl = p2.pl - p1.pl;
  diff.b = p2.b - p1.b;
  diff.em = p2.em - p1.em;
  diff.i = p2.i - p1.i;
  diff.s = p2.s - p1.s;
  diff.tt = p2.tt - p1.tt;
  diff.u = p2.u - p1.u;
  diff.color = (p1.color == p2.color) ? '0' : p2.color;
  diff.size = (p1.size == p2.size) ? -2 : p2.size;
  
  return diff;
}

int property_length(field *bottom, field *top, property diff, property context, 
		    property *new_context, char *ot, char *ct, char *colors, int *sizes)
{
  field *b;
  int max = -1;
  int value = 0;
  int lastuseful;

  if (bottom == NULL)
    return 0;



  if (diff.b)
    {
      lastuseful = value = 0;
      b = bottom;
      while(b->prop.b == bottom->prop.b || b->prop.pl)
	{
	  value++;
	  if (b->prop.b == diff.b)
	    lastuseful = value;
	  if (b->next != NULL && b != top)
	    b = b->next;
	  else 
	    break;
	}
      //fprintf(stderr, "B:    %d\n", value);
      value = lastuseful;
      if (value > max)
	{
	  max = value;
	  strcpy(ot, "<B>");
	  strcpy(ct, "</B>");
	  (* new_context) = context;
	  (* new_context).b = diff.b;      
	}
    }

  //needs to be redone
  if (diff.em)
    {
      lastuseful = value = 0;
      b = bottom;
      while(b->prop.em == bottom->prop.em || b->prop.pl)
	{
	  value++;
	  if (b->prop.em == diff.em)
	    lastuseful = value;
	  if (b->next != NULL && b != top)
	    b = b->next;
	  else 
	    break;
	}
      //fprintf(stderr, "EM:   %d\n", value);
      value = lastuseful;
      if (value > max)
	{
	  max = value;
	  strcpy(ot, "<EM>");
	  strcpy(ct, "</EM>");
	  (* new_context) = context;
	  if (!(* new_context).s)
	    (* new_context).em = ((*new_context).em + 3) % 2;
	}
    }

  if (diff.i)
    {
      lastuseful = value = 0;
      b = bottom;
      while(b->prop.i == bottom->prop.i || b->prop.pl)
	{
	  if (b->prop.i == diff.i)
	    lastuseful = value;
	  value++;
	  if (b->next != NULL && b != top)
	    b = b->next;
	  else 
	    break;
	}
      //fprintf(stderr, "I:    %d\n", value);
      value = lastuseful;
      if (value > max)
	{
	  max = value;
	  strcpy(ot, "<I>");
	  strcpy(ct, "</I>");
	  (* new_context) = context;
	  (* new_context).i = diff.i;      
	}
    }

  if (diff.s)
    {
      lastuseful = value = 0;
      b = bottom;
      while(b->prop.s == bottom->prop.s || b->prop.pl)
	{
	  value++;
	  if (b->prop.s == diff.s)
	    lastuseful = value;
	  if (b->next != NULL && b != top)
	    b = b->next;
	  else 
	    break;
	}
      //fprintf(stderr, "S:    %d\n", value);
      value = lastuseful;
      if (value > max)
	{
	  max = value;
	  strcpy(ot, "<S>");
	  strcpy(ct, "</S>");
	  (* new_context) = context;
	  (* new_context).s = diff.s;      
	  (* new_context).em = (diff.s) ? 0 : (* new_context).em;
	}
    }

  if (diff.tt)
    {
      lastuseful = value = 0;
      b = bottom;
      while(b->prop.tt == bottom->prop.tt || b->prop.pl)
	{
	  value++;
	  if (b->prop.tt == diff.tt)
	    lastuseful = value;
	  if (b->next != NULL && b != top)
	    b = b->next;
	  else 
	    break;
	}
      value = lastuseful;
      //fprintf(stderr, "TT:   %d\n", value);
      if (value > max)
	{
	  max = value;
	  strcpy(ot, "<TT>");
	  strcpy(ct, "</TT>");
	  (* new_context) = context;
	  (* new_context).tt = diff.tt;      
	}
    }
  if (diff.u)
    {
      lastuseful = value = 0;
      b = bottom;
      while(b->prop.u >= (context.u + 1) || b->prop.pl)
	{
	  value++;
	  if (b->prop.u >= (context.u + 1))
	    lastuseful = value;
	  if (b->next != NULL && b != top)
	    b = b->next;
	  else 
	    break;
	}
      value = lastuseful;
      //fprintf(stderr, "U:    %d\n", value);
      if (value > max)
	{
	  max = value;
	  strcpy(ot, "<U>");
	  strcpy(ct, "</U>");
	  (* new_context) = context;
	  (* new_context).u++;      
	}
    }

  if (diff.size != -2)
    {
      lastuseful = value = 0;
      b = bottom;
      //      fprintf(stderr, "%2x:%2x:%d:%d\n",b->prop.size + 1, (* sizes), 
      //      !((int)pow(2, b->prop.size + 1) & (* sizes)), diff.size);
      while(!((int)pow(2, b->prop.size + 1) & (* sizes)))
	{
	  value++;
	  if (b->prop.size == diff.size)
	    lastuseful = value;
	  if (b->next != NULL && b != top)
	    b = b->next;
	  else 
	    break;
	}
      value = lastuseful;
      //      fprintf(stderr, "SIZE: %d\n", value);
      if (value > max)
	{
	  max = value;
	  sprintf(ot, "<%1d>", diff.size); 
	  sprintf(ct, "</%1d>", diff.size); 
	  (* new_context) = context;
	  (* new_context).size = diff.size;      
	}
    }

  if (diff.color != '0')
    {
      lastuseful = value = 0;
      b = bottom;
      while(strchr(colors, b->prop.color) == NULL)
	{
	  value++;
	  if (b->prop.color == diff.color)
	    lastuseful = value;
	  if (b->next != NULL && b != top)
	    b = b->next;
	  else 
	    break;
	}
      value = lastuseful;
      //fprintf(stderr, "COLOR:%d\n", value);
      if (value > max)
	{
	  max = value;
	  sprintf(ot, "<%c>", diff.color); 
	  sprintf(ct, "</%c>", diff.color); 
	  (* new_context) = context;
	  (* new_context).color = diff.color;      
	}
    }  

  if (diff.pl)
    {
      value = 0;
      b = bottom;
      while(b->prop.pl == bottom->prop.pl)
	{
	  value++;
	  if (b->next != NULL && b != top)
	    b = b->next;
	  else 
	    break;
	}
      //fprintf(stderr, "PL:   %d\n", value);
      if (value > max)
	{
	  max = value;
	  strcpy(ot, "<PL>");
	  strcpy(ct, "</PL>");
	  (* new_context) = context;
	  (* new_context).pl = diff.pl;      
	  (* new_context).s = 0;      
	  (* new_context).b = 0;      
	  (* new_context).i = 0;      
	  (* new_context).tt = 0;      
	  (* new_context).em = 0;      
	  (* new_context).u = 0;      
	}
    }

  if ((* new_context).color == diff.color)
    {  
      colors[value = strlen(colors)] = diff.color;
      colors[value + 1] = '\0';
    }
  else if ((* new_context).size == diff.size)
    {
      //      fprintf(stderr, "%2x:%2d:", (* sizes), diff.size);
      (* sizes) += pow(2, (diff.size + 1));
      //fprintf(stderr, "%2x\n", (* sizes));
    }

  return max;
}

void addstring(char **text, int *size, char *c)
{
  int l, l2;
     
  //  fprintf(stderr, "adding '%s' to '%s' and getting ", c, (* text));

  l = strlen(* text);
  l2 = strlen(c);
  
  if ((* text) == NULL) 
    {
      (* size) = 100;
      (* text) = (char *)malloc(sizeof(char) * (* size));
      (* text)[0] = '\0';
      l = 0;
    }
  while ((* size) < (l + 1 + l2)) 
    {
      (* size) += 100;
      (* text) = realloc((* text), sizeof(char) * (* size));
    }

  strcat((* text) + l, c);
  (* text)[l + l2] = '\0';

  //  fprintf(stderr, "'%s'\n", (* text));

  return;
}
